Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation

Imports System.ComponentModel
Imports System.Threading

Partial Public Class Window1
    ' The BackgroundWorker that will perform the long task.
    Private WithEvents m_BackgroundWorker As New BackgroundWorker()

    Public Sub New()
        MyBase.New()

        Me.InitializeComponent()

        ' Insert code required on object creation below this point.

    End Sub

    ' Start the long task.
    Private Sub btnDoSomething_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnDoSomething.Click
        ' Prepare the BackgroundWorker.
        m_BackgroundWorker.WorkerReportsProgress = True

        ' Display the progress controls.
        prgWorking.Value = 0
        prgWorking.Visibility = Windows.Visibility.Visible
        lblWorking.Visibility = Windows.Visibility.Visible
        btnDoSomething.Visibility = Windows.Visibility.Hidden

        ' Asynchronously start the routine
        ' that does the long calculation.
        m_BackgroundWorker.RunWorkerAsync()
    End Sub

    ' Simulate a long task.
    Private Sub BackgroundWorker_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles m_BackgroundWorker.DoWork
        Dim value As Integer = 0
        Dim rand As New Random()
        Do While value < 100
            ' Wait a little while.
            Thread.Sleep(200)

            ' Add a bit to the progress.
            value += rand.Next(10, 20)

            ' Update the UI thread.
            Console.WriteLine("Worker: " & value)
            m_BackgroundWorker.ReportProgress(value)
        Loop
    End Sub

    ' Display the progress.
    Private Sub BackgroundWorker_ProgressChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles m_BackgroundWorker.ProgressChanged
        prgWorking.Value = e.ProgressPercentage
    End Sub

    ' Reset the UI.
    Private Sub BackgroundWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles m_BackgroundWorker.RunWorkerCompleted
        prgWorking.Visibility = Windows.Visibility.Hidden
        lblWorking.Visibility = Windows.Visibility.Hidden
        btnDoSomething.Visibility = Windows.Visibility.Visible
    End Sub
End Class
